package org.processmining.plugins.tracealignment;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.connections.ConnectionManager;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.framework.plugin.events.Logger.MessageLevel;

@Plugin(name = "Trace Alignment Frame Visualization", returnLabels = { "Visualizion of Trace Alignment" }, returnTypes = { JComponent.class }, parameterLabels = { "AlignmentFrame" }, userAccessible = false)
@Visualizer
public class AlignmentFrameVisualization {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, AlignmentFrame frame) {
		ConnectionManager cm = context.getConnectionManager();
		try {
			if (cm.getConnections(TraceAlignmentConnection.class, context) != null) {
				return frame;
			}
			return null;
		} catch (ConnectionCannotBeObtained e) {
			// No connections available
			context.log("Connection does not exist", MessageLevel.DEBUG);
			return null;
		}
	}
}
