package org.processmining.plugins.tracealignment;

import javax.swing.UIManager;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Trace Alignment", parameterLabels = { "log" }, returnLabels = { "Trace Alignment" }, returnTypes = { AlignmentFrame.class }, userAccessible = true, help = "Trace Alignment")
public class TraceAlignmentPlugin {
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "R.P. Jagadeesh Chandra 'JC' Bose", email = "j.c.b.rantham.prabhakara@tue.nl", website = "www.processmining.org")
	@PluginVariant(variantLabel = "Default Summary, user-specified clusters.", requiredParameterLabels = { 0 })
	public static AlignmentFrame traceAlignment(UIPluginContext context, XLog log) {

		// Set the look at feel for the alignment frame
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}

		AlignmentFrame frame = new AlignmentFrame(context, log);
		context.addConnection(new TraceAlignmentConnection(frame));
		return frame;
	}
}
