package org.processmining.plugins.tracealignment.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;

import org.processmining.plugins.tracealignment.AlignmentFrame;
import org.processmining.plugins.tracealignment.swingx.FixedWidthTextField;
import org.processmining.plugins.tracealignment.swingx.Utils;

@SuppressWarnings("serial")
public class EditSeqAnnDialog extends EditSeqAnnBaseDialog {
	//TODO changed from original - needs to add a base dialog class with lot of functionality; check original
	private JButton okButton, cancelButton, deleteAllButton;
	private JTextField annotationTextField;

	JTextPane p;

	public EditSeqAnnDialog(AlignmentFrame owner, DisplayProperties displayProperties, Sequence sequence) {
		//    	super(owner, "Edit Sequence Annotation "+sequence.getName());
		//TODO the super below is when EditSeqAnnBaseDialog class is implemented
		super(owner, "Edit Sequence Annotation: " + sequence.getName(), displayProperties, sequence);
		this.sequence = sequence;
		this.owner = owner;
		rebuildGUI();

		pack();
		// but make sure width is at least 500 incase we get scroll...
		Dimension size = getSize();

		// limit size...
		if (size.height > 422) {
			size.height = 422;
		}
		if (size.width < 600) {
			size.width = 600;
		}
		setSize(size.width, size.height);
		setLocationRelativeTo(owner);
	}

	public void rebuildGUI() {
		getContentPane().removeAll();

		JPanel subpanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();

		subpanel.setLayout(gb);

		int row = 0;

		String name;
		String selectedAnnotation;

		selectedAnnotation = sequence.getDisplayedAnnotationName();

		annotationTextField = new FixedWidthTextField(sequence.getAnnotation(), 40);

		name = null;
		JRadioButton radioButton = new JRadioButton("", name == selectedAnnotation);

		row++;

		sequenceTextField = new FixedWidthTextField(sequence.getName(), 40);

		Utils.addClipboardBindings(sequenceTextField);
		Utils.addToGridBag(subpanel, gb, new JLabel("Sequence Name: "), 0, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
				GridBagConstraints.EAST);
		Utils.addToGridBag(subpanel, gb, sequenceTextField, 1, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
				GridBagConstraints.CENTER);

		name = "SeqName";
		radioButton = new JRadioButton("", name == selectedAnnotation);
		radioButton.setName(name);

		displayedAnnotationButtonGroup.add(radioButton);
		Utils.addToGridBag(subpanel, gb, radioButton, 2, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
				GridBagConstraints.WEST);
		row++;

		// the following code assumes that s.getExtraAnnotationNames(true)
		// will ALSO include ALL the standard names in the standard order...
		//        prop_names = s.getExtraAnnotationNames(true);
		//        prop_value_tf = new JTextField[prop_names.length];
		//        prop_label =  new LinkLabel[prop_names.length];
		//        
		//        if (prop_names != null && prop_names.length > 0)
		//        {
		//            for (int i=0; i<prop_names.length; i++)
		//            {
		//                // phdana link2 ->
		//                String value = s.getAnnotation(prop_names[i]);
		//                
		//                LinkLabel label = createButton(prop_names[i],i,value);
		//                prop_label[i] = label;
		//                
		//                Utils.addToGridBag(subpanel, gb,label,
		//                        0, row, 1, 1, 1, 1,
		//                        GridBagConstraints.BOTH,
		//                        GridBagConstraints.EAST);
		//                
		//                prop_value_tf[i] = createTF(value, i);
		//                // phdana link2 <-
		//                
		//                
		//                Utils.addClipboardBindings(prop_value_tf[i]);
		//                Utils.addToGridBag(subpanel, gb,
		//                        prop_value_tf[i],
		//                        1, row, 1, 1, 1, 1,
		//                        GridBagConstraints.BOTH, GridBagConstraints.CENTER);
		//                
		//                name = prop_names[i];
		//                rb = new JRadioButton("",name.equalsIgnoreCase(selectedAnnotation));
		//                rb.setName(name);
		//                displayedAnnotationButtons.add(rb);
		//                Utils.addToGridBag(subpanel, gb,
		//                        rb,
		//                        2, row, 1, 1, 1, 1,
		//                        GridBagConstraints.BOTH, GridBagConstraints.WEST);
		//                row++;
		//            }
		//        }

		JScrollPane scroll = new JScrollPane(subpanel);
		getContentPane().add(scroll, BorderLayout.CENTER);

		subpanel = new JPanel();

		JButton add_button = new JButton("Add...");
		add_button.setActionCommand("addAnnotation");
		add_button.addActionListener(this);
		subpanel.add(add_button);
		JButton delete_button = new JButton("Delete...");
		delete_button.setActionCommand("deleteAnnotation");
		delete_button.addActionListener(this);
		subpanel.add(delete_button);
		subpanel.add(Box.createHorizontalStrut(20));

		okButton = new JButton("OK");
		okButton.addActionListener(this);
		subpanel.add(okButton);

		deleteAllButton = new JButton("Delete");
		deleteAllButton.addActionListener(this);
		subpanel.add(deleteAllButton);

		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		subpanel.add(cancelButton);

		getContentPane().add(subpanel, BorderLayout.SOUTH);

		// to force this to work we hide/show the button panel...
		subpanel.setVisible(false);
		subpanel.setVisible(true);

		// ok the delet all button is just silly...hide it
		deleteAllButton.setVisible(false);
	}

	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);

		if (e.getSource() == okButton) {
			String ann = annotationTextField.getText();

			// if blank then turn into null
			if ((ann != null) && (ann.length() < 1)) {
				ann = null;
			}

			try {
				sequence.setName(sequenceTextField.getText());
			} catch (Exception exc) {
				// if we can't change it...oh well!
			}

			// TODO
			// owner.revalidateAndRepaintAll();

			dispose();
		} else if (e.getSource() == deleteAllButton) {
			// System.out.println("Inside delete........");
			if (JOptionPane.showConfirmDialog(this, "Are you sure you want " + "to delete ALL annotation information?",
					"Comfirm Delete", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
				sequence.deleteAnnotation();
				dispose();
			}
		} else if (e.getSource() == cancelButton) {
			dispose();
		}
		return;
	}
}
