package org.processmining.plugins.tracealignment.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.processmining.plugins.tracealignment.AlignmentFrame;
import org.processmining.plugins.tracealignment.swingx.FixedWidthTextField;
import org.processmining.plugins.tracealignment.swingx.JListX;
import org.processmining.plugins.tracealignment.swingx.Utils;

@SuppressWarnings("serial")
public class EditSequenceNameDialog extends EditSeqAnnBaseDialog {

	private JButton okButton, cancelButton;

	public EditSequenceNameDialog(AlignmentFrame owner, DisplayProperties props, Sequence s) {
		super(owner, "Edit Sequence Name: " + s.getName(), props, s);
		rebuildGUI();

		//		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		//        getContentPane().setLayout(new BorderLayout());
		pack();
		// but make sure width is at least 500 in case we get scroll...
		Dimension size = getSize();

		// limit size...
		if (size.height > 422) {
			size.height = 422;
		}
		if (size.width < 400) {
			size.width = 400;
		}
		setSize(size.width, size.height);
		setLocationRelativeTo(owner);
	}

	public void rebuildGUI() {
		getContentPane().removeAll();

		JPanel subpanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();

		subpanel.setLayout(gb);

		int row = 0;

		//		String name;
		// TODO changed from original next line
		//		String selectedAnnotation = sequence.getDisplayedAnnotationName();

		sequenceTextField = new FixedWidthTextField(sequence.getName(), 40);

		//		name = null;
		//		JRadioButton rb = new JRadioButton("", name == selectedAnnotation);
		row++;
		sequenceTextField = new FixedWidthTextField(sequence.getName(), 40);
		// seq_tf.setEnabled(false);
		//		Utils.addClipboardBindings(sequenceTextField);
		Utils.addToGridBag(subpanel, gb, new JLabel("Trace Name: "), 0, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
				GridBagConstraints.EAST);
		Utils.addToGridBag(subpanel, gb, new JLabel(sequence.getName()), 1, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
				GridBagConstraints.CENTER);
		row++;

		//		Utils.addToGridBag(subpanel, gb, sequenceTextField, 1, row, 1, 1, 1, 1,
		//				GridBagConstraints.BOTH, GridBagConstraints.CENTER);

		//		name = "SeqName";
		//		rb = new JRadioButton("", name == selectedAnnotation);
		//		rb.setName(name);
		//		displayedAnnotationButtonGroup.add(rb);
		//		Utils.addToGridBag(subpanel, gb, rb, 2, row, 1, 1, 1, 1,
		//				GridBagConstraints.BOTH, GridBagConstraints.WEST);
		//		row++;

		int noDuplicateTraces = sequence.getNoDuplicates();
		if (noDuplicateTraces > 0) {
			JListX duplicatePINameList = new JListX(sequence.getDuplicateProcessInstanceNameList().toArray());
			duplicatePINameList.setEnabled(false);
			Utils.addToGridBag(subpanel, gb, new JLabel(" "), 0, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
					GridBagConstraints.EAST);
			Utils.addToGridBag(subpanel, gb, new JLabel(" "), 1, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
					GridBagConstraints.CENTER);
			row++;
			Utils.addToGridBag(subpanel, gb, new JLabel("No. Identical Traces: "), 0, row, 1, 1, 1, 1,
					GridBagConstraints.BOTH, GridBagConstraints.EAST);
			Utils.addToGridBag(subpanel, gb, new JLabel(noDuplicateTraces + ""), 1, row, 1, 1, 1, 1,
					GridBagConstraints.BOTH, GridBagConstraints.CENTER);
			row++;
			Utils.addToGridBag(subpanel, gb, new JLabel(" "), 0, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
					GridBagConstraints.EAST);
			Utils.addToGridBag(subpanel, gb, new JLabel(" "), 1, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
					GridBagConstraints.CENTER);
			row++;
			JScrollPane duplicateTraceScrollPane = new JScrollPane(duplicatePINameList);

			Utils.addToGridBag(subpanel, gb, new JLabel("Identical Trace Name List"), 0, row, 1, 1, 1, 1,
					GridBagConstraints.BOTH, GridBagConstraints.EAST);
			Utils.addToGridBag(subpanel, gb, duplicateTraceScrollPane, 1, row, 1, 1, 1, 1, GridBagConstraints.BOTH,
					GridBagConstraints.CENTER);

			row++;
		}

		// TODO deleted props related stuff from original

		JScrollPane scroll = new JScrollPane(subpanel);
		getContentPane().add(scroll, BorderLayout.CENTER);

		subpanel = new JPanel();

		// Add, delete and cancel currently doesn't make any sense so commenting them out
		/*
		 * JButton addButton = new JButton("Add...");
		 * addButton.setActionCommand("addAnnotation");
		 * addButton.addActionListener(this); subpanel.add(addButton);
		 * 
		 * JButton deleteButton = new JButton("Delete...");
		 * deleteButton.setActionCommand("deleteAnnotation");
		 * deleteButton.addActionListener(this); subpanel.add(deleteButton);
		 * subpanel.add(Box.createHorizontalStrut(20));
		 */

		okButton = new JButton("OK");
		okButton.addActionListener(this);
		subpanel.add(okButton);

		/*
		 * cancelButton = new JButton("Cancel");
		 * cancelButton.addActionListener(this); subpanel.add(cancelButton);
		 */
		getContentPane().add(subpanel, BorderLayout.SOUTH);

		// to force this to work we hide/show the button panel...
		subpanel.setVisible(false);
		subpanel.setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);

		if (e.getSource() == okButton) {
			try {
				String newSeqName = sequenceTextField.getText();
				sequence.setName(newSeqName);
			} catch (Exception exc) {
				// if we can't change it...oh well!
			}

			//TODO deleted some stuff
			//			owner.revalidateAndRepaintAll();

			dispose();
		} else if (e.getSource() == cancelButton) {
			dispose();
		}
		return;
	}
}
