package org.processmining.plugins.tracealignment.ui;

import java.awt.Dialog;
import java.awt.Frame;

import javax.swing.ListCellRenderer;

import org.processmining.plugins.tracealignment.swingx.ItemSelectionDialog;
import org.processmining.plugins.tracealignment.ui.Sequence.LineAnnotation;

@SuppressWarnings("serial")
public class LineAnnotationSelectionDialog extends ItemSelectionDialog {
	public LineAnnotationSelectionDialog(Dialog owner, String title, String msg, String itemListTitle,
			LineAnnotation[] lineAnnotationArray, int[] selectedIndicies) {
		super(owner, title, msg, itemListTitle, lineAnnotationArray, selectedIndicies);
	}

	public LineAnnotationSelectionDialog(Frame owner, String title, String msg, String itemListTitle,
			LineAnnotation[] lineAnnotations, int[] selectedIndices) {
		super(owner, title, msg, itemListTitle, lineAnnotations, selectedIndices);
	}

	public LineAnnotation[] getSelectedLineAnnotations() {
		Object[] selectedItems = getSelectedItems();
		if (selectedItems == null) {
			return null;
		}
		LineAnnotation[] selectedLineAnnotations = new LineAnnotation[selectedItems.length];
		System.arraycopy(selectedItems, 0, selectedLineAnnotations, 0, selectedItems.length);
		return selectedLineAnnotations;
	}

	protected ListCellRenderer getListCellRenderer() {
		return new LineAnnotationListCellRenderer();
	}
}
