package org.processmining.plugins.tracealignment.util;

import java.util.ArrayList;
import java.util.Map;

import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;

/**
 * 
 * @author R. P. Jagadeesh Chandra Bose (JC)
 * @email j.c.b.rantham.prabhakara@tue.nl
 * @date 02 July 2009
 * @version 1.0
 */
public class EncodeTraces {
	private final ArrayList<String> charStreamList;

	public EncodeTraces(Map<String, String> activityCharMap, XLog log) throws EncodingNotFoundException {
		charStreamList = new ArrayList<String>();

		StringBuilder charStreamBuilder = new StringBuilder();
		StringBuilder activityBuilder = new StringBuilder();

		XAttributeMap attributeMap;

		for (XTrace trace : log) {
			charStreamBuilder.setLength(0);
			for (XEvent event : trace) {
				attributeMap = event.getAttributes();

				activityBuilder.setLength(0);
				activityBuilder.append(attributeMap.get("concept:name").toString()).append("-").append(
						attributeMap.get("lifecycle:transition").toString());

				if (activityCharMap.containsKey(activityBuilder.toString())) {
					charStreamBuilder.append(activityCharMap.get(activityBuilder.toString()));
				} else {
					throw new EncodingNotFoundException(activityBuilder.toString());
				}
			}
			charStreamList.add(charStreamBuilder.toString());
		}
	}

	public ArrayList<String> getCharStreamList() {
		return charStreamList;
	}
}
